/* $Id: archive.h,v 1.4 2001/04/18 00:11:20 richdawe Exp $ */

/*
 *  archive.h - Archive handling functions for zippo
 *  Copyright (C) 1999, 2001 by Richard Dawe
 *      
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __libzippo_archive_h__
#define __libzippo_archive_h__

#include <limits.h>

#ifdef __cplusplus
extern "C" {
#endif

/* --- Data structures --- */

typedef struct {
  char name[PATH_MAX];
  unsigned long size;
} ARCHIVE_FILE_INFO;

/* --- Functions --- */
extern char **archive_get_toc       (const char *archive);
extern int    archive_extract_file  (const char *archive, const char *file, 
                                     const char *dest);
extern int    archive_get_file_info (const char *archive, const char *file,
                                     ARCHIVE_FILE_INFO *afi);

extern char *archive_extract_file_to_memory      (const char *archive, 
                                                  const char *file);
extern char *archive_extract_text_file_to_memory (const char *archive, 
                                                  const char *file);

#ifdef __cplusplus
}
#endif

#endif	/* __libzippo_archive_h__ */
